;-------------------------------------------------------------------------------------
;interrupt routine;format:<CURindex>,<paraFUNC>,<paraPOS>,<PARAx>,<paraMINx>,<paraMAXx>
;-------------------------------------------------------------------------------------
;ingration fully remote == als aktiver master nur passiv !
;-> 
SPI_SLAVE:
;	push	r0	;r0 on stack
;	push	r1	;r1 on stack
;	push	zh	;zh on stack
;	push	zl	;zl on stack
;	push	r17	;r17 on stack
;	push	r16	;r16 on stack
	push	r15	;r15 on stack
	in	r15,sreg
	;
_SPI_SLAVEgo:


	;jetzt byte counter laden
	lds	r16,spiDATctIST	
	tst	r16	;erstes byte empfangen
	brne	_SPI02sub
	;comBUF startadresse
	ldi	zh,high(SPIstring)
	ldi	zl,low(SPIstring)
	;erstes byte aus spi buffer
	in  r16,spdr	;spi register lesen
	st	z+,r16
	clr		r16 ;new
	ldi	r17,5		;nein == 6 bytes(-1)
	sts	spiDATctSOLL,r17
	rjmp	_SPI02start	;weiter zur datenbergabe
	;aktuelle comBUF adresse holen
	;& daten speichern
_SPI02sub:
	lds	zh,spiBUFadrH
	lds	zl,spiBUFadrL
	lds	r17,spiDATctSOLL
	in	r0,spdr	;spi register lesen
	st	z+,r0
_SPI02start:
	;comBUF sichern
	sts	spiBUFadrH,zh
	sts	spiBUFadrL,zl
	;
	;range prfen
	;&jetzt busy setzen
	lds	zl,comFLAGspi
	sbr	zl,1<<spiBUSY	;busy...
	sbr	zl,1<<spiWORKIN
	;range?
	cp	r16,r17		;ist<soll ?
	brlo	_SPI05sub	
	;>= fertig
	;cbr	zl,1<<spiBUSY	;wird im spi_M modul gelscht
	sbr	zl,1<<newSPIdata
	;data counter = 0
	clr	r16
	rjmp	_SPbk
	;noch nicht erreicht...
_SPI05sub:
	inc	r16
	rjmp	_SPbk	


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_SPbk:	
	sts	comFLAGspi,zl
	sts	spiDATctIST,r16
	out	sreg,r15
	pop	r15	;restore r15
;	pop	r16	;restore r16
;	pop	r17	;restore r17
;	pop	zl	;restore zl
;	pop	zh	;restore zh
;	pop	r1	;restore r1
;	pop	r0	;restore r0
	reti

